searchNodes=[{"ref":"Uploadex.html","title":"Uploadex","type":"module","doc":"Context Helper functions for handling files."},{"ref":"Uploadex.html#create_with_file/2","title":"Uploadex.create_with_file/2","type":"function","doc":"Inserts the changeset and store the record files in a database transaction, so if the files fail to be stored the record will not be created."},{"ref":"Uploadex.html#delete_with_file/2","title":"Uploadex.delete_with_file/2","type":"function","doc":"Deletes the record and all of its files. This is not in a database transaction, since the delete operation never returns errors."},{"ref":"Uploadex.html#get_files_url/3","title":"Uploadex.get_files_url/3","type":"function","doc":"Returns the record&#39;s files (as defined in the definition get_files) URL, replacing the uploader.base_directory() with the endpoint URL. To provide the endpoint URL, there are two options: Provide the endpoint_url directly as a string Provide the Phoenix.Endpoint module"},{"ref":"Uploadex.html#get_files_url/4","title":"Uploadex.get_files_url/4","type":"function","doc":"Similar to get_files_url/3, but instead of returning all files defined in the definition get_files, returns the URL for the specified files. This is useful when one record has multiple file fields."},{"ref":"Uploadex.html#update_with_file/2","title":"Uploadex.update_with_file/2","type":"function","doc":"Similar to update_with_file/3, but does not delete previous files."},{"ref":"Uploadex.html#update_with_file/3","title":"Uploadex.update_with_file/3","type":"function","doc":"Updates the record and its files in a database transaction, so if the files fail to be stored the record will not be created. This function also deletes files that are no longer referenced."},{"ref":"Uploadex.Definition.html","title":"Uploadex.Definition","type":"module","doc":"An Uploader definition. This is a wrapper on top of the Arc.Definition, adding some extra functionalities to it. Usage defmodule MyApp.MyUploader do use Uploadex.Definition, repo: MyApp.Repo ## Functions required for Uploadex.Definition def base_directory do Path.join(:code.priv_dir(:my_app), &quot;static/&quot;) end def get_files(%MyApp.User{photo: photo}), do: photo def get_files(%MyApp.Company{} = company) do company |&gt; MyApp.Repo.preload(:photos) |&gt; Map.get(:photos) |&gt; Enum.map(&amp; &amp;1.file) end ## We can also define the functions for Arc.Definition here def storage_dir(_version, {_file, %User{id: user_id}}) do Path.join(base_directory(), &quot;/uploads/users/\#{user_id}&quot;) end def storage_dir(_version, {_file, %Company{id: id}}) do Path.join(base_directory(), &quot;/uploads/companies/\#{id}&quot;) end end"},{"ref":"Uploadex.FileProcessing.html","title":"Uploadex.FileProcessing","type":"module","doc":"Process files in Base64"},{"ref":"Uploadex.FileProcessing.html#process_base64/1","title":"Uploadex.FileProcessing.process_base64/1","type":"function","doc":"This function currently only supports binaries in base 64 because it&#39;s not clear what are the other use cases for this."},{"ref":"Uploadex.Files.html","title":"Uploadex.Files","type":"module","doc":"Functions to store and delete files. This is an abstraction on top of the Arc.Actions.Store and Arc.Actions.Delete, dealing with all files of a given record."},{"ref":"Uploadex.Files.html#delete_files/2","title":"Uploadex.Files.delete_files/2","type":"function","doc":"Deletes all files for a record. Used in delete functions."},{"ref":"Uploadex.Files.html#delete_previous_files/3","title":"Uploadex.Files.delete_previous_files/3","type":"function","doc":"Deletes all files that changed. Used in update functions."},{"ref":"Uploadex.Files.html#store_files/2","title":"Uploadex.Files.store_files/2","type":"function","doc":"Stores all files of a record, as defined by the uploader. Used in insert functions. Since uploader.store only accepts maps, files that are not in that format are ignored. This allows for assigning an existing file to a record without recreating it, by simply passing it&#39;s filename."},{"ref":"Uploadex.Storage.Local.html","title":"Uploadex.Storage.Local","type":"module","doc":"Local storage. Use this module instead of arc&#39;s to have the same pattern between upload and fetch. The problem is that to upload, arc expects a mao with the key :filename, but when fetching it expects a :file_name, so you can&#39;t store a record with an upload and then take the result to get the file."},{"ref":"Uploadex.Storage.Local.html#delete/3","title":"Uploadex.Storage.Local.delete/3","type":"function","doc":""},{"ref":"Uploadex.Storage.Local.html#put/3","title":"Uploadex.Storage.Local.put/3","type":"function","doc":""},{"ref":"Uploadex.Storage.Local.html#url/4","title":"Uploadex.Storage.Local.url/4","type":"function","doc":""},{"ref":"Uploadex.Upload.html","title":"Uploadex.Upload","type":"module","doc":"Ecto type that handles upload"},{"ref":"Uploadex.Upload.html#cast/1","title":"Uploadex.Upload.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query When returning {:error, keyword()}, the returned keyword list will be preserved in the changeset errors, similar to Changeset.add_error/4. Passing a :message key, will override the default message. It is not possible to override the :type key. For {:array, CustomType} or {:map, CustomType} the returned keyword list will be erased and the default error will be shown. Callback implementation for Ecto.Type.cast/1."},{"ref":"Uploadex.Upload.html#dump/1","title":"Uploadex.Upload.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"Uploadex.Upload.html#load/1","title":"Uploadex.Upload.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receives an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"Uploadex.Upload.html#type/0","title":"Uploadex.Upload.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"Uploadex.Uploader.html","title":"Uploadex.Uploader","type":"behaviour","doc":"Behaviour of an Uploader Definition."},{"ref":"Uploadex.Uploader.html#c:base_directory/0","title":"Uploadex.Uploader.base_directory/0","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:do_get_files/1","title":"Uploadex.Uploader.do_get_files/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:get_files/1","title":"Uploadex.Uploader.get_files/1","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#c:repo/0","title":"Uploadex.Uploader.repo/0","type":"callback","doc":""},{"ref":"Uploadex.Uploader.html#t:file/0","title":"Uploadex.Uploader.file/0","type":"type","doc":""},{"ref":"Uploadex.Uploader.html#t:record/0","title":"Uploadex.Uploader.record/0","type":"type","doc":""}]